#!/bin/sh

# Run the url.txt generation scripts in the given tree to generate
# updated url.txt files.

urls=$1 # path to tree of url.txt files
shift

binpath=$(cd "$(dirname "$0")" && pwd)
PATH="$binpath:$PATH"

if test -z "$urls"; then
  echo "Please give me the url tree prefix."
  exit 1
fi

urls=$(cd "$urls" && pwd)

if test -z "$urls"; then
  echo "Absolute path did not work out."
  exit 1
fi

cd $urls &&
find . -name 'get-urls*.sh' | while read i
do
  dir=$(dirname "$i")
  #echo "$dir" >&2
  script=$(basename "$i")
  (
    cd "$dir" &&
    case "$script" in
    get-urls.sh)
      cp urls.txt oldurls.tmp 2>/dev/null || touch oldurls.tmp
      sh "$script" oldurls.tmp > newurls.tmp
      cat oldurls.tmp newurls.tmp | sort -uV > urls.txt
      rm oldurls.tmp newurls.tmp
    ;;
    get-urls2.sh)
      sh "$script" urls.txt
    ;;
    *)
      echo "How to call $script?" >&2
    ;;
    esac
  )
done &&
find . -name 'get-files*.sh' | while read i
do
  dir=$(dirname "$i")
  #echo "$dir" >&2
  script=$(basename "$i")
  (
    cd "$dir" &&
    case "$script" in
    get-files.sh)
      cp files.txt oldfiles.tmp 2>/dev/null || touch oldfiles.tmp
      sh "$script" oldfiles.tmp > newfiles.tmp
      cat oldfiles.tmp newfiles.tmp | sort -uV > files.txt
      rm oldfiles.tmp newfiles.tmp
    ;;
    get-files2.sh)
      sh "$script" files.txt
    ;;
    *)
      echo "How to call $script?" >&2
    ;;
    esac
  )
done
